/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # *
/* # Unite d'analyse lexicale           # */
/* # BRUNO Emmanuel 1998-2006           # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */

#include <stdio.h>
#include <string.h>
#include "algo_lexical.h"

/* ### ANALYSEUR LEXICAL ### */
/*
  parametres  :
  variables globales:
  lex_entree: pointeur sur le fichier ouvert en lecture.
    
  description :
  lit le fichier en entree
  met a jour la variable lex_sym avec le type du symbole lu.
  met a jour la variable lex_val et/ou lex_num avec la valeur du symbole lu.
*/

/* # Recherche d'un entier ou d'un reel #
 lecture d'un entier ou d'un reel et mise a jour de lex_sym (a s_entier ou s_reel), de lex_num et de lex_val
*/
void nombre()
{
}


/* FONCTION NOMBRE AVEC LECTURE NUMERIQUE (Facultatif)*/
/*void nombre()
{
}*/

/* # ajoute un mot-cle et son symbole a la table des mots-cle # */
void ajoute_mot_cle(char *nom,int sym)
{
}

/* #
procedure qui lit un identificateur et met a jour lex_sym et lex_val
ATTENTION elle verifie si l'identificateur est un mot cle (ie dans table_mots_cle)
 et affecte correctement lex_sym.
 # */
void identificateur()
{
}


/* # Procedure d'initialisation du parser
   Ouverture du fichier en lecture
   ajoute de tous les mot-cles a la table des mot-cles.
   initialise lex_ch
 # */

void lex_init(char *nomfichier)
{
  /* Ouverture du flux d'entree */
  lex_entree=fopen(nomfichier,"r");
  lex_ch=fgetc(lex_entree);
  /* Creation de la table des mots cles */
  nb_mots_cle=0;
  ajoute_mot_cle("div",s_div);
  ajoute_mot_cle("mod",s_mod);
  ajoute_mot_cle("et",s_et);
  ajoute_mot_cle("ou",s_ou);
  ajoute_mot_cle("Algorithme",s_algorithme);
  ajoute_mot_cle("Dclaration",s_declaration);
  ajoute_mot_cle("Dbut",s_debut);
  ajoute_mot_cle("Fin",s_fin);
  ajoute_mot_cle("rel",s_t_reel);
  ajoute_mot_cle("entier",s_t_entier);
  ajoute_mot_cle("boolen",s_t_booleen);
  ajoute_mot_cle("rels",s_t_reels);
  ajoute_mot_cle("entiers",s_t_entiers);
  ajoute_mot_cle("boolens",s_t_booleens);
  ajoute_mot_cle("des",s_des);
  ajoute_mot_cle("un",s_un);
  ajoute_mot_cle("demander_une_valeur_pour",s_demander_une_valeur_pour);
  ajoute_mot_cle("affecter_la_valeur_de",s_affecter_la_valeur_de);
  ajoute_mot_cle("",s_a);
  ajoute_mot_cle("montrer_la_valeur_de",s_montrer_la_valeur_de);
  ajoute_mot_cle("si",s_si);
  ajoute_mot_cle("alors",s_alors);
  ajoute_mot_cle("sinon",s_sinon);
  ajoute_mot_cle("finsi",s_finsi);
  ajoute_mot_cle("tant_que",s_tant_que);
  ajoute_mot_cle("faire",s_faire);
  ajoute_mot_cle("fintq",s_fintq);
  ajoute_mot_cle("vrai",s_vrai);
  ajoute_mot_cle("faux",s_faux);
  ajoute_mot_cle("non",s_non);
}

/* # fermeture du fichier contenant le programme a lire # */
void lex_fin()
{
  fclose(lex_entree);
}

/* # lecture du prochain indentificateur et recherche de son symbole # */
void lire_symbole_quelquonque()
     /* 
	procedure principale qui en lisant un caracteres determine de quel symbole il s'agit * + - ... ou
	appelle la recherche d'un identificateur ou d'un nombre. Elle met a jour lex_sym et lex_val.
	ATTENTION
	aux symboles <= >= et <>
     dans le cas d'un caractere non reconnu elle retourne lex_sym:=s_vide lex_val:=''
     a la fin du fichier retourner lex_sym : = s_eof et lex_val :=''
     */
{
}

/* ### Procedure qui utilise lire_symbole_quelquonque, mais qui recherche le prochain symbole
 valide, c'est a dire different de s_vide, puis elle met a jour lex_sym et lex_val.
 P.S. C'est elle qui permet de traiter les suites d'espaces et de tabulations et les retours a la ligne.
 ### */
void lire_symbole()
{
  do
    lire_symbole_quelquonque();
  while (lex_sym == s_vide);
}




