/* ###################################### */
/* #                                    # */
/* #  Un compilateur pour le langage    # */
/* #        ALGO                        # */
/* #                                    # *
/* # Unite d'analyse lexicale           # */
/* # BRUNO Emmanuel 1998-2006           # */
/* # bruno@univ-tln.fr                  # */
/* ###################################### */


/* --- CONSTANTES --- */
/* Longueur maximale d'un identificateur */
#define longueur_ident 30

/* Dfinition des Symboles*/
#define s_ident 1
#define s_parent_g		 2
#define  s_parent_d		 3
#define  s_etoile		 4
#define  s_slash		 5
#define  s_div		 6
#define  s_mod		 7
#define  s_plus		 8
#define  s_moins		 9
#define  s_ou			 10
#define  s_et			 11
#define  s_egal		 12   
#define  s_inf		 13
#define  s_sup		 14
#define  s_inf_eg		 15
#define  s_sup_eg		 16
#define  s_diff		 17
#define  s_virgule		 18
#define  s_algorithme		 19
#define  s_declaration	 20
#define  s_debut		 21
#define  s_fin		 22
#define  s_reel		 23
#define  s_entier		 24
#define  s_t_booleen		 25
#define  s_t_reels		 26
#define  s_t_entiers		 27
#define  s_t_booleens		 28
#define  s_un			 29
#define  s_des		 30
#define  s_demander_une_valeur_pour 31
#define  s_affecter_la_valeur_de 32
#define  s_montrer_la_valeur_de 33
#define  s_tant_que		 34
#define  s_si			 35
#define  s_a			 36
#define  s_alors		 37
#define  s_sinon		 38
#define  s_finsi		 39
#define  s_faire		 40
#define  s_fintq		 41
#define  s_vrai		 42
#define  s_faux		 43
#define  s_eof		 44
#define  s_nombre		 45
#define  s_non		 46
#define  s_vide		 47
#define  s_point		 48
#define  s_t_entier		 49
#define  s_t_reel		 50
#define  max_mots_cle 30

/* VARIABLES GLOBALES */
FILE  *lex_entree;  /* Fichier contenant le programme */
int    lex_sym;	    /* type du symbole courant */
char   lex_val[255];/* valeur du symbole courant */
double  lex_num;	    /* valeur du nombre courant */	
char   lex_ch;	    /* dernier caratere lu */
int    nb_mots_cle; /* nombre de mots cles dans le langage */

/* structure decrivant un mot cle (son symbole et sa valeur) */
typedef struct mot_cle
{
  int sym;
  char *val;
} s_mot_cle;

/* table contenant la liste de tous les mot-cles et de leur symbole */
s_mot_cle table_mots_cle[max_mots_cle];
